AC_DEFUN(TI_FIX_SHELL,[
AC_MSG_CHECKING(for good shell)
if test "$BASH" = '' && test `uname` = HP-UX; then
  AC_MSG_RESULT([no, switching to bash])
  case [$]# in
    0) exec bash - "[$]0"        ;;
    *) exec bash - "[$]0" "[$]@" ;;
  esac
else
  AC_MSG_RESULT(yes)
fi])

AC_DEFUN(TI_COMPILER,[
AC_PROG_$1
if test $2 = yes; then $3="$$3 -Wall"; fi])

AC_DEFUN(TI_ENV_DEFAULT,[
AC_MSG_CHECKING(for $1 in environment)
case "$[$1]" in
  '') [$1]="[$2]"
      AC_MSG_RESULT([no, defaulting to \"[$2]\"])
      ;;
  *)  AC_MSG_RESULT([yes, using \"$[$1]\"]) ;;
esac
])

AC_DEFUN(TI_OPTION_HELP,[  --$1 substr([                     ],len($1))$2])

AC_DEFUN(TI_IF_ENABLED,[
AC_ARG_ENABLE($1,TI_OPTION_HELP(enable-$1,$2))
case "$enable_[]patsubst([$1], -, _)" in
  '' | no) $4 ;;
  *)  $3 ;;
esac
])

AC_DEFUN(TI_IF_DISABLED,[
AC_ARG_ENABLE($1,TI_OPTION_HELP(disable-$1,$2))
case "$enable_[]patsubst([$1], -, _)" in
  '' | yes) $4 ;;
  *)   $3 ;;
esac
])

AC_DEFUN(TI_IF_ENABLED_WITH_AUTO,[
AC_ARG_ENABLE($1,TI_OPTION_HELP(enable-$1,$2))
AC_ARG_ENABLE($1,TI_OPTION_HELP(disable-$1,$2))
case "$enable_[]patsubst([$1], -, _)" in
  no)  $4 ;;
  yes) $3 ;;
  *)   $5 ;;
esac
])

AC_DEFUN(TI_SUBST,[
$1="$2"
AC_SUBST($1)])

AC_DEFUN(TI_SUBST_FILE,[
$1="$2"
AC_SUBST_FILE($1)])

AC_DEFUN(TI_CHECK_PROGS,[
case "$$1" in
  '') AC_CHECK_PROGS($1,$2)
      ;;
esac
case "$$1" in
  '') AC_MSG_ERROR(cannot find $3)
      ;;
esac])

AC_DEFUN(TI_PATH_PROGS,[
case "$$1" in
  '') AC_PATH_PROGS($1,$2)
      ;;
esac
case "$$1" in
  '') AC_MSG_ERROR(cannot find $3)
      ;;
esac])

dnl TI_CHECK_LIB_OBSOLETE is obsolete. Do not use.
AC_DEFUN(TI_CHECK_LIB_OBSOLETE,[
oldflags="$LDFLAGS"
LDFLAGS="-L$1 $LD_FLAGS"
AC_CHECK_LIB($2, $3, $4, $5, $6)
LDFLAGS="$oldflags"])

dnl TI_CHECK_LIB(ld-flags, libraries, C-flags, name-of-main-function,
dnl              function-to-search-for, action-if-found, action-if-not-found)
AC_DEFUN(TI_CHECK_LIB,[
AC_MSG_CHECKING(for $5 in $2)
oldflags="$LDFLAGS"
LDFLAGS="$1 $LD_FLAGS"
oldlibs="$LIBS"
LIBS="$2 $LIBS"
oldcflags="$CFLAGS"
CFLAGS="$3 $CFLAGS"
AC_TRY_LINK([
extern void $5 ();
#define main $4
], [
#undef main
$5 ();
],
AC_MSG_RESULT(yes)
$6,
AC_MSG_RESULT(no)
$7)
LDFLAGS="$oldflags"
LIBS="$oldlibs"]
CFLAGS="$oldcflags")

AC_DEFUN(TI_FIX_EXEC,[[
case "$CONFIG_FILES" in
  *$1*) chmod +x $1 ;;
esac]])


AC_DEFUN(TI_TRY_CFLAG,[
oldflags="$CFLAGS"
CFLAGS="$CFLAGS $1"
AC_LANG_SAVE
AC_LANG_C
AC_TRY_COMPILE([], [], $2=yes, $2=no)
AC_LANG_RESTORE
CFLAGS="$oldflags"])


AC_DEFUN(TI_TRY_CXXFLAG,[
oldflags="$CXXFLAGS"
CXXFLAGS="$CXXFLAGS $1"
AC_LANG_SAVE
AC_LANG_CPLUSPLUS
AC_TRY_COMPILE([], [], $2=yes, $2=no)
AC_LANG_RESTORE
CXXFLAGS="$oldflags"])


AC_DEFUN(TI_TRY_CACHE_CHECK,[
AC_CACHE_CHECK($1, tc_cv_$2,
AC_TRY_COMPILE([$3], [$4], tc_cv_$2=yes, tc_cv_$2=no))
if test "$tc_cv_$2" = yes; then
  $5
fi])


AC_DEFUN(TI_IFDEF,[
AC_TRY_CPP([
#ifndef $1
# error
#endif], $2, $3)])


AC_DEFUN(TI_FAMILY_CACHE_CHECK,[
AC_REQUIRE_CPP
AC_CACHE_CHECK(for $1 compiler family, $2, [
  $2=unknown
  TI_IFDEF(__GNUC__, $2=GNU)
  TI_IFDEF(__KCC, $2=KAI)
  TI_IFDEF(__SUNPRO_C, $2=Sun)
  TI_IFDEF(_CRAYC, $2=Cray)
])])
