#ifndef _INCLUDE_TITANIUM_IL_CONTEXT_H_
#define _INCLUDE_TITANIUM_IL_CONTEXT_H_

#include <set>

class MethodTypeNode;
class MethodCallNode;

typedef set< MethodCallNode *, less< MethodCallNode * > > StaleSet;


struct LocalContext
{
  LocalContext( StaleSet & );
  LocalContext( const LocalContext &, MethodTypeNode & );
  LocalContext( const LocalContext &, bool );

  StaleSet &stale;
  MethodTypeNode * const method;
  const bool isExported;
};
  

inline LocalContext::LocalContext( StaleSet &stale )
  : stale( stale ),
    method( 0 ),
    isExported( true )
{
}


inline LocalContext::LocalContext( const LocalContext &parent,
				   MethodTypeNode &method )
  : stale( parent.stale ),
    method( &method ),
    isExported( parent.isExported )
{
}
  

inline LocalContext::LocalContext( const LocalContext &parent,
				   bool isExported )
  : stale( parent.stale ),
    method( parent.method ),
    isExported( isExported && parent.isExported )
{
}
  

#endif // !_INCLUDE_TITANIUM_IL_CONTEXT_H_
