#include "AST.h"


void AllocateArrayNode::localEnact( const LocalEnactContext &context )
{
  ExprNode::localEnact( context );

  bool changed = dtype()->localEnactType( context );
  changed |= dimExprs()->localEnactDimension( context );

  if (changed)
      localReportChange( "array allocation", *type() );
}


////////////////////////////////////////////////////////////////////////


bool TreeListNode::localEnactDimension( const LocalEnactContext &context )
{
  bool changed = false;
  foriter (child, allChildren(), ChildIter)
    {
      AllocateArrayDimensionNode &dimension = static_cast< AllocateArrayDimensionNode & >( **child );
      assert( !strcmp( dimension.oper_name(), "AllocateArrayDimensionNode" ) );
      changed |= dimension.localEnactDimension( context );
    }
  return changed;
}


bool AllocateArrayDimensionNode::localEnactDimension( const LocalEnactContext &context )
{
  return localEnactBits( context, _flags );
}
