#include "AST.h"
#include "context.h"
#include "decls.h"


void TreeNode::inferLocalChildren( const LocalContext &context ) const
{
  for (unsigned sweep = arity(); sweep--; )
    child( sweep )->inferLocalTree( context );
}


void TreeNode::inferLocal( const LocalContext & )
{
}


////////////////////////////////////////////////////////////////////////


void ConstructorDeclNode::inferLocalChildren( const LocalContext &context ) const
{
  LocalContext subcontext( context, *decl()->methodType() );
  TreeNode::inferLocalChildren( subcontext );
}


void MethodDeclNode::inferLocalChildren( const LocalContext &context ) const
{
  LocalContext subcontext( context, *decl()->methodType() );
  TreeNode::inferLocalChildren( subcontext );
}
