#include "AST.h"
#include "solver.h"


void TypeNode::localSubcastTo( const TypeNode &target ) const
{
  if (localInferable())
    solver().identicalTo( *this, target );
}


////////////////////////////////////////////////////////////////////////


void ArrayTypeNode::localSubcastTo( const TypeNode &target ) const
{
  TypeNode::localSubcastTo( target );

  if (target.isArrayType())
    elementType()->localSubcastTo( *target.elementType() );
  else
    elementType()->localConservative();
}


void TypeNameNode::localSubcastTo( const TypeNode &target ) const
{
  TypeNode::localSubcastTo( target );

  if (target.isArrayType())
    target.elementType()->localConservative();
}
