#include <netdb.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/param.h>
#include <signal.h>
#include <stdio.h>

char *RUNTIME_MODEL = "cray-t3e";

#include "main.h"

extern void region_init(void);

/* Setup a trap handler for SIGFPE (floating point exception) */

int MYPROC = -1;
int PROCS = -1;

int curr_sade_num = 0;

int main(int argc, char **argv)
{
  MYPROC = _my_pe();
  PROCS = _num_pes();

  if (getenv("TI_FREEZE"))
    {
      char hostname[MAXHOSTNAMELEN] = "(unknown)";
      volatile int frozen = 1;

      gethostname(hostname, sizeof(hostname));
      printf("frozen for debugger: host %s, pid %d\n", hostname, getpid());

      while (frozen)
	;
    }

  bcast_init();
  region_init();

  srand(MYPROC);

  sigignore(SIGFPE);

  ti_main(argc, argv);

  return 0;
}
