#ifndef __titanium_monitor_t_h_
#define __titanium_monitor_t_h_

/* Cray T3E Monitor Type */

/*
  Note that the "long" and "short" are purposely used (instead of a j* type)
  and must match the shmem functions called within monitor.c.

  Fields:
  lock_owner  Set to the MYPROC of the owner of the lock. If the lock is
              free, it is set to NO_LOCK_OWNER.

  nesting     Track the nesting level of the lock acquires. The lock is freed
              only when the nesting level returns to zero.
*/

typedef struct {
  long lock_owner;
  short nesting;
} titanium_monitor_t;

#endif /* !__titanium_monitor_t_h_ */
