#include "lapi_comm.h"

extern swclock_handle_t profclock;

static unsigned pending;
static pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t done = PTHREAD_COND_INITIALIZER;


void barrier_init()
{
  pending = THREADS_PER_NODE;
  pthread_cond_init(&done, NULL);
  pthread_mutex_init(&mutex, NULL);
}

static barrnum = 0;

/* When all the local threads have gotten to the barrier, call the global
   barrier routine. Thus we can be sure that when the global barrier completes,
   all remote threads must have hit the barrier also. */
void barrier()
{
  LAPI_Probe(lapi_hndl);
  pthread_mutex_lock( &mutex );

  if (--pending) {
    pthread_cond_wait( &done, &mutex );
  }
  else
    {
      LAPI_Gfence(lapi_hndl);
      pending = THREADS_PER_NODE;
      barrnum++;
      pthread_cond_broadcast( &done );
    }
  pthread_mutex_unlock( &mutex );
  LAPI_Probe(lapi_hndl);
}

void local_barrier() {
  pthread_mutex_lock( &mutex );

  LAPI_Probe(lapi_hndl);
  if (--pending) {
    pthread_cond_wait( &done, &mutex );
  }
  else
    {
      pending = THREADS_PER_NODE;
      barrnum++;
      pthread_cond_broadcast( &done );
    }
  pthread_mutex_unlock( &mutex );
  LAPI_Probe(lapi_hndl);
}  
