#ifndef INCLUDE_TITANIUM_RUNTIME_MONITOR_MACROS_H
#define INCLUDE_TITANIUM_RUNTIME_MONITOR_MACROS_H

#include "monitor.h"
#include "titanium_monitor_t.h"


#ifdef HAVE_MONITORS
# define MONITOR_FETCH_CLASS( holder )  TO_GLOBAL( (holder), 0, &class_monitor )
# define MONITOR_FETCH_INSTANCE_( form, holder, object )  FIELD_ADDR_ ## form(  holder, object, monitor )
#else /* no monitors */
# define MONITOR_FETCH_CLASS( holder )
# define MONITOR_FETCH_INSTANCE_( form, holder, object )
#endif /* no monitors */

#define MONITOR_FETCH_INSTANCE_LOCAL(  holder, object )  MONITOR_FETCH_INSTANCE_( LOCAL,  holder, object )
#define MONITOR_FETCH_INSTANCE_GLOBAL( holder, object )  MONITOR_FETCH_INSTANCE_( GLOBAL, holder, object )
#define MONITOR_LOCK(   holder )  monitorEnter( TO_LOCAL( holder ), TO_PROC( holder ) )
#define MONITOR_UNLOCK( holder )  monitorExit(  TO_LOCAL( holder ), TO_PROC( holder ) )


#endif /* !INCLUDE_TITANIUM_RUNTIME_MONITOR_MACROS_H */
